%define daemon_group apache
%define radiusdirectory radiusclient-ng
%define daemon_user monitor

%define nagios_cfg /opt/monitor/etc/nagios.cfg


Summary: OP5 Monitor is a highly flexible network monitoring tool
Name: monitor-config
Version: %{op5version}
Release: %{op5release}%{?dist}
BuildArchitectures: noarch
License: GPLv2+
Group: op5/monitor
URL: https://www.itrsgroup.com
Source0: %name-%version.tar.gz
Prefix: /opt/monitor/etc
BuildRoot: %{_tmppath}/%{name}-%{version}
Requires: op5-monitor-user
BuildRequires: shadow-utils
Requires: shadow-utils


%description
OP5 Monitor is a system for monitoring network hosts and its various
services. This package provide a basic default configuration

%package test
Summary: Empty test helper
Group: op5/monitor
%if 0%{?rhel} >= 8
# Make the circular dependency to Naemon weak - install it and run tests if possible.
Recommends: op5-naemon
%else
Requires: op5-naemon
%endif

%description test
Empty test helper

%prep
%setup -q


%build

%install
rm -rf %buildroot

install -d %buildroot%prefix/
install -d %buildroot%prefix/oconf
install -d %buildroot%prefix/mconf
install -d %buildroot%prefix/extra-oconf
install -d %buildroot/opt/monitor/var
install -d %buildroot/opt/monitor/var/rw
install -d %buildroot/opt/monitor/var/archives
install -d %buildroot/opt/monitor/var/spool/checkresults

install -m 664 *.cfg %buildroot%prefix/
sed --follow-symlinks -i "s|@RADIUSDIRECTORY@|%{radiusdirectory}|" %buildroot%prefix/checkcommands.cfg
ln -s nagios.cfg %buildroot%prefix/naemon.cfg
ln -s naemon.log %buildroot/opt/monitor/var/nagios.log

%pre
if test -f /opt/monitor/var/nagios.log -a ! -h /opt/monitor/var/nagios.log; then
	mv /opt/monitor/var/nagios.log /opt/monitor/var/naemon.log
fi

%post
# unconditionally update url_html_path in cgi.cfg
sed --follow-symlinks -i 's,^\(url_html_path=\).*,\1/monitor.old,' %prefix/cgi.cfg

# Remove Nagios 2 vars from configuration file
sed --follow-symlinks -i \
	-e /^aggregate_status_updates/d \
	-e /^downtime_file/d \
	-e /^comment_file/d \
	-e s/service_reaper_frequency/check_result_reaper_frequency/ \
		%nagios_cfg

# Remove Nagios 3 vars from configuration file
sed --follow-symlinks -i \
	-e /^sleep_time/d \
	-e /^command_check_interval/d \
	-e /^enable_failure_prediction/d \
	-e /^enable_embedded_perl/d \
	-e /^use_embedded_perl_implicitly/d \
	-e /^auth_file/d \
	-e /^p1_file/d \
	-e /^external_command_buffer_slots/d \
		%nagios_cfg

# Add dropdir statements so other packages don't have to sed naemon.cfg
if ! grep -q cfg_dir=extra-oconf %nagios_cfg; then
	echo "cfg_dir=extra-oconf" >> %nagios_cfg
fi

if ! grep -q 'include_dir' %nagios_cfg; then
	echo 'include_dir=mconf' >> %nagios_cfg
fi

if ! grep -q 'query_socket' %nagios_cfg; then
	echo 'query_socket=/opt/monitor/var/rw/nagios.qh' >> %nagios_cfg
fi

# Remove variables not needed by naemon
sed --follow-symlinks -i \
	-e /^nagios_user/d \
	-e /^nagios_group/d \
	-e /^log_rotation_method/d \
	-e /^lock_file/d \
	-e /^service_inter_check_delay_method/d \
	-e /^max_service_check_spread/d \
	-e /^service_interleave_factor/d \
		%nagios_cfg

%clean
rm -rf %{buildroot}


%files
%defattr(660,%daemon_user,%daemon_group,-)
%dir %attr(770,%daemon_user,%daemon_group) %prefix
%config(noreplace) %prefix/cgi.cfg
%config(noreplace) %prefix/eventhandlers.cfg
%config(noreplace) %prefix/hostgroups.cfg
%config(noreplace) %prefix/servicegroups.cfg
%config(noreplace) %prefix/checkcommands.cfg
%config(noreplace) %prefix/hostdependencies.cfg
%config(noreplace) %prefix/hosts.cfg
%prefix/naemon.cfg
%config(noreplace) %prefix/nagios.cfg
%config(noreplace) %prefix/servicedependencies.cfg
%config(noreplace) %prefix/services.cfg
%config(noreplace) %prefix/contactgroups.cfg
%config(noreplace) %prefix/hostescalations.cfg
%config(noreplace) %prefix/serviceescalations.cfg
%config(noreplace) %prefix/timeperiods.cfg
%config(noreplace) %prefix/contacts.cfg
%config(noreplace) %prefix/hostextinfo.cfg
%config(noreplace) %prefix/misccommands.cfg
%config(noreplace) %prefix/serviceextinfo.cfg
%config(noreplace) %attr(600,%daemon_user,root) %prefix/resource.cfg
%dir %attr(775,%daemon_user,%daemon_group) %prefix/oconf
%dir %attr(775,%daemon_user,%daemon_group) %prefix/extra-oconf
%dir %attr(775,%daemon_user,%daemon_group) %prefix/mconf
%dir %attr(775,%daemon_user,%daemon_group) /opt/monitor/var
/opt/monitor/var/nagios.log
%dir %attr(775,%daemon_user,%daemon_group) /opt/monitor/var/rw
%dir %attr(775,%daemon_user,%daemon_group) /opt/monitor/var/archives
%dir %attr(775,%daemon_user,%daemon_group) /opt/monitor/var/spool/checkresults

%files test
